# mindoverflow

The time management app built with GTK and libadwaita, designed with stack memory and pomodoro in mind.

## What is the goal of this project?

After using pomodoro technique for quite a long time, I notices that I always do one thing before switching tasks in the next work interval (a.k.a the *pomo*): I copy links to the websites of all of the browser tabs I have open, and paste them into a text file, so that I can return right back to the thing I was working on without spending time on remembering all of the stuff I have been doing.

So, I called that the "stack memory management" technique, where the *stack* meant the note I had for each task. It actually has nothing to do with the stack data structure, but since the name has already stuck, I am going to keep it.

But the problem was, I had to use multiple apps to perform this: timer, browser and a text editor. At the first glance, it might seem like it's not that big of a deal. However, in reality this used to fill my desktop with an overwhelming amount of windows. But if that wasn't enough, a lot of this software didn't work as inteded. A lot of times the pomodoro timers didn't make any sounds, or would incorrectly monitor the time spent on a task.

So this project was born to fix those issues. To make a pomodoro proguctivity timer that is:

* Reliable.
    + No weird sound or notification issues.
    + Simple and well-defined method of calculating the work time.
* Flexible.
    + *Pomo*/break times can be configued.
    + *Pomos*/breaks can be skipped.
    + *Pomos*/breaks can be paused.
* Compatible.
    + All of the configuration files and data should be written in an easy-to-understand format and directly available to the user.
        - To support syncthing for sync.
        - To be able to edit outside of the app.
* Built with stack memory in mind.
    + 